<?php
use Automattic\WooCommerce\Blocks\Payments\Integrations\AbstractPaymentMethodType;

defined( 'ABSPATH' ) || exit;

final class TransactionCloudBlocksSupport extends AbstractPaymentMethodType
{
	protected $name = 'transaction_cloud';

	public function is_active() {
		return 'yes' === $this->get_setting('enabled', 'no');
	}

    public function initialize() {
		$this->settings = get_option('woocommerce_transaction_cloud_settings', []);
	}

    function get_payment_method_script_handles() {
        $version      = TC_WOO_VERSION;
		$path         = plugins_url('build/transaction-cloud-payment-block.js', __FILE__);
		$handle       = 'wc-payment-method-transaction-cloud';
		$dependencies = ['wp-hooks'];

		wp_register_script( $handle, $path, $dependencies, $version, true );

		return [ $handle ];
	}

    public function get_payment_method_data() {
		return [
			'title'       => $this->get_setting('title'),
			'description' => $this->get_setting('description'),
			'supports'    => $this->get_supported_features(),
            'iconurl'     => plugins_url('../assets/icon.svg', __FILE__),
            'paymenturl'  => plugins_url('../assets/payment-methods.png', __FILE__),
		];
	}
}
