<?php

if (!defined('ABSPATH')) {
    exit;
}

require_once 'Includes.php';

class TransacionCloudWoo
{
    protected static $_instance = null;

    public static function instance() {
        if (is_null(self::$_instance)) {
            self::$_instance = new self();
            self::$_instance->init();
        }

        return self::$_instance;
    }

    public function init() {
        // Load plugin textdomain for translations.
        add_action('init', [$this, 'load_plugin_textdomain']);

        // Check if WooCommerce is active.
        if (in_array('woocommerce/woocommerce.php', apply_filters('active_plugins', get_option('active_plugins')), true)) {
            // Include the payment gateway class.
            require_once TC_WOO_PLUGIN_DIR . 'includes/TransacionCloudPaymentGateway.php';

            // Add the payment gateway.
            add_filter('woocommerce_payment_gateways', [$this, 'add_payment_gateway']);
        }
    }

    public function load_plugin_textdomain() {
        load_plugin_textdomain('transaction-cloud-for-woocommerce', false, dirname(plugin_basename(TC_WOO_PLUGIN_FILE)) . '/languages/');
    }

    public function add_payment_gateway($gateways) {
        $gateways[] = 'TransacionCloudPaymentGateway';
        return $gateways;
    }
}
