<?php
/**
 * Plugin Name: TransactionCloud for WooCommerce
 * Plugin URI: https://transaction.cloud
 * Update URI: https://transaction.cloud/documentation/v1/woocommerce
 * Description: Versatile suite of standalone payment methods designed to seamlessly integrate with your existing buying journey.
 * Version: 1.2.10
 * Author: TransactionCloud
 * Author URI: https://transaction.cloud
 * Text Domain: transaction-cloud-for-woocommerce
 * Domain Path: /languages
 */

if (!defined('ABSPATH')) {
    exit;
}

// Define constants.
define('TC_WOO_VERSION', '1.2.10');
define('TC_WOO_PLUGIN_FILE', __FILE__);
define('TC_WOO_PLUGIN_DIR', plugin_dir_path(__FILE__));

add_action('plugins_loaded', 'initTransactionCloudGateway');
add_action('woocommerce_blocks_loaded', 'addTransactionCloudBlock');

function initTransactionCloudGateway()
{
    if (!class_exists('WC_Payment_Gateway')) {
        return;
    }

    require_once TC_WOO_PLUGIN_DIR . 'includes/TransacionCloudWoo.php';

    // Initialize the plugin.
    TransacionCloudWoo::instance();
}

function addTransactionCloudBlock() {
    if ( class_exists( 'Automattic\WooCommerce\Blocks\Payments\Integrations\AbstractPaymentMethodType' ) ) {
        require_once 'Blocks/TransactionCloudPayment.php';
        add_action(
            'woocommerce_blocks_payment_method_type_registration',
            function( Automattic\WooCommerce\Blocks\Payments\PaymentMethodRegistry $registry ) {
                $container = Automattic\WooCommerce\Blocks\Package::container();
                // registers as shared instance.
                $container->register(
                    TransactionCloudBlocksSupport::class,
                    function() {
                        return new TransactionCloudBlocksSupport();
                    }
                );
                $registry->register(
                    $container->get( TransactionCloudBlocksSupport::class )
                );
            },
            5
        );
    }
}
